/**
  * Autor: Victor Carbune
  * Echipa SD, 2012
  *
  * License: LGPL
  */

#ifndef __BINARY_TREE_H
#define __BINARY_TREE_H

#include <cstdio>
#include <cstdlib>

template <typename T>
class BinaryTree
{
public:
    BinaryTree();
    ~BinaryTree();

    // Inspect if the current node has data.
    bool hasData();

    // Set data for current node.
    void setData(T data);

    // Set left subtree.
    void setLeftSubtree(BinaryTree<T> *node);

    // Get the left subtree.
    BinaryTree<T> *getLeftSubtree();

    // Set right subtree.
    void setRightSubtree(BinaryTree<T> *node);

    // Get the right subtree.
    BinaryTree<T> *getRightSubtree();

    // Insert data recursively randomly where it is possible.
    void insert(T data);

    // Insert data into left subtree.
    void insertLeft(T data);

    // Insert data into right subtree.
    void insertRight(T data);

    // Display the binary tree to output.
    void displayTree(int indentLevel);

private:
    BinaryTree<T> *leftNode;
    BinaryTree<T> *rightNode;

    T *pData;
};

#endif // __BINARY_TREE_H
